import 'package:flutter/material.dart';
import 'package:getx_extended/export.dart';

class PageDetector extends StatelessWidget {
  TabController? controller;
  Rx<int> page;
  Widget Function(Rx<int> rx) child;

  PageDetector({
    this.controller,
    required this.page,
    required this.child,
  });

  @override
  Widget build(
    BuildContext context,
  ) =>
      page.toWidget(
        (rx) => NotificationListener(
          onNotification: (notification) {
            final current = controller?.index ??
                DefaultTabController.of(context)?.index ??
                0;
            if (rx.value != current) {
              rx.value = current;
            }
            return true;
          },
          child: child(rx),
        ),
      );
}
