import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:getx_extended/export.dart';

class RxTabBar<T> extends StatelessWidget implements PreferredSizeWidget {
  Rx<int> page;
  List<T> source;
  Widget Function(T item, bool isSelected) builder;

  RxTabBar({
    required this.source,
    required this.builder,
    required this.page,
  });

  @override
  Widget build(BuildContext context) => TabBar(
        tabs: [
          ...source.mapIndexed(
            (index, e) => Padding(
              padding: const EdgeInsets.all(8.0),
              child: page.toWidget(
                (rx) => Opacity(
                  opacity: rx.value == index ? 1 : 0.3,
                  child: builder(e, rx.value == index),
                ),
              ),
            ),
          )
        ],
        indicatorColor: Colors.transparent,
        isScrollable: true,
      );

  @override
  Size get preferredSize => Size.fromHeight(kToolbarHeight);
}
